<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<h5 class="fw-bold mb-3" [innerText]="messages.EDIT_NOTIFICATIONS_TITLE"></h5>
<div class="max-width-60">

  <form
    class="ls-form"
    autocomplete="on">

    <div class="form-group mt-3">
      <label
        for="notificationRedirectEmail"
        [innerText]="messages.REDIRECTION_MAIL_LABEL"></label>
      <input
        id="notificationRedirectEmail"
        class="form-control"
        type="email"
        autocomplete="on"
        [(ngModel)]="userPreferences.notificationsRedirectionMail"
        [ngModelOptions]="{standalone: true}"
        [placeholder]="currentUser.email || ''">
    </div>
    <ls-options-list
      [optionsList]="notificationOptions"
      (change)="onSpecificNotificationValueChange()">
    </ls-options-list>
    <div class="form-group">
      <label [innerText]="messages.NOTIFICATION_FREQUENCY_LABEL"></label>
      <div class="w-100 btn-group btn-group-toggle">
        <button
          class="btn btn-outline-primary {{ isNotificationDisabled() ? 'active' : '' }}"
          (click)="userPreferences.notificationsCronFrequency = 'none'"
          [innerText]="messages.NOTIFICATION_FREQUENCY_NONE"></button>
        <button
          class="btn btn-outline-primary {{ isNotificationSingle() ? 'active' : '' }}"
          (click)="userPreferences.notificationsCronFrequency = 'single_notifications'"
          [innerText]="messages.NOTIFICATION_FREQUENCY_SINGLE"></button>
        <button
          class="btn btn-outline-primary {{ isNotificationHourly() ? 'active' : '' }}"
          (click)="userPreferences.notificationsCronFrequency = '0 0 * * * *'"
          [innerText]="messages.NOTIFICATION_FREQUENCY_HOURLY"></button>
        <button
          class="btn btn-outline-primary {{ isNotificationDaily() ? 'active' : '' }}"
          (click)="userPreferences.notificationsCronFrequency = '0 0 6 * * *'"
          [innerText]="messages.NOTIFICATION_FREQUENCY_DAILY"></button>
        <button
          class="btn btn-outline-primary {{ isNotificationWeekly() ? 'active' : '' }}"
          (click)="userPreferences.notificationsCronFrequency ='0 0 7 * * 1'"
          [innerText]="messages.NOTIFICATION_FREQUENCY_WEEKLY">
        </button>
      </div>
    </div>

    <div class="form-inline">
      <div
        *ngIf="isNotificationHourly()"
        class="pt-2 form-group">
        <label for="notificationHourSelect">
          {{ messages.EVERY_HOURS }}
          <ng-select
            class="mx-2 hour-selector"
            id="notificationHourSelect"
            [clearable]="false"
            [(ngModel)]="userPreferences.notificationsCronFrequency"
            [ngModelOptions]="{standalone: true}">
            <ng-option value="0 0 * * * *">1</ng-option>
            <ng-option value="0 0 */2 * * *">2</ng-option>
            <ng-option value="0 0 */3 * * *">3</ng-option>
            <ng-option value="0 0 */4 * * *">4</ng-option>
            <ng-option value="0 0 */5 * * *">5</ng-option>
            <ng-option value="0 0 */6 * * *">6</ng-option>
            <ng-option value="0 0 */12 * * *">12</ng-option>
          </ng-select>
          {{ messages.HOUR_S }}
        </label>
      </div>
    </div>

    <div class="form-inline">
      <div
        *ngIf="isNotificationDaily()"
        class="pt-2 form-group">
        <label for="notificationDaySelect">
          {{ messages.EVERY_DAYS }}
          <ng-select
            class="mx-2 hour-selector"
            id="notificationDaySelect"
            [clearable]="false"
            [(ngModel)]="userPreferences.notificationsCronFrequency"
            [ngModelOptions]="{standalone: true}">
            <ng-option value="0 0 6 * * *">6</ng-option>
            <ng-option value="0 0 7 * * *">7</ng-option>
            <ng-option value="0 0 8 * * *">8</ng-option>
            <ng-option value="0 0 10 * * *">10</ng-option>
            <ng-option value="0 0 12 * * *">12</ng-option>
            <ng-option value="0 0 14 * * *">14</ng-option>
            <ng-option value="0 0 16 * * *">16</ng-option>
            <ng-option value="0 0 18 * * *">18</ng-option>
            <ng-option value="0 0 20 * * *">20</ng-option>
          </ng-select>
          {{ messages.HOURS }}
        </label>
      </div>
    </div>

    <div class="form-inline">
      <div
        *ngIf="isNotificationWeekly()"
        class="pt-2 form-group">
        <label
          for="notificationWeekSelect"
          [innerText]="messages.EVERY_WEEK">
        </label>
        <ng-select
          class="week-selector"
          id="notificationWeekSelect"
          [clearable]="false"
          [(ngModel)]="userPreferences.notificationsCronFrequency"
          [ngModelOptions]="{standalone: true}">
          <ng-option value="0 0 7 * * 1" [innerText]="messages.MONDAY"></ng-option>
          <ng-option value="0 0 7 * * 2" [innerText]="messages.TUESDAY"></ng-option>
          <ng-option value="0 0 7 * * 3" [innerText]="messages.WEDNESDAY"></ng-option>
          <ng-option value="0 0 7 * * 4" [innerText]="messages.THURSDAY"></ng-option>
          <ng-option value="0 0 7 * * 5" [innerText]="messages.FRIDAY"></ng-option>
          <ng-option value="0 0 7 * * 6" [innerText]="messages.SATURDAY"></ng-option>
          <ng-option value="0 0 7 * * 7" [innerText]="messages.SUNDAY"></ng-option>
        </ng-select>
      </div>
    </div>
  </form>

  <div class="w-100">
    <button
      [text]="messages.PROFILE_VALIDATE"
      [processing]="isProcessing"
      (click)="saveForm()"
      ls-button-save
      class="mt-4">
    </button>
  </div>

</div>
